//+------------------------------------------------------------------
//|                                         Trend Quality Q indicator
//|                                                            mladen 
//|                                    
//| as Published in TASC 22:04 article
//| Trend Quality indicator" by David Sepiashvili
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    8
#property indicator_color1     DeepSkyBlue
#property indicator_color2     PaleVioletRed
#property indicator_color3     DimGray
#property indicator_color4     HotPink
#property indicator_color5     PaleVioletRed
#property indicator_color6     PaleVioletRed
#property indicator_color7     LimeGreen
#property indicator_color8     LimeGreen
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_style5     STYLE_DOT
#property indicator_style6     STYLE_DOT
#property indicator_style7     STYLE_DOT
#property indicator_style8     STYLE_DOT
#property indicator_levelcolor DimGray


//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern int    TrendPeriod             =   4;
extern int    NoisePeriod             = 250;
extern double CorrectionFactor        =   2;
extern int    FastLength              =   7;
extern int    SlowLength              =  15;
extern int    Price                   = PRICE_CLOSE;
extern int    DzLookBackBars          = 35;
extern double DzStartBuyProbability1  = 0.25;
extern double DzStartBuyProbability2  = 0.35;
extern double DzStartSellProbability1 = 0.25;
extern double DzStartSellProbability2 = 0.35;

//
//
//
//
//

double trendQu[];
double trendQd[];
double trendQ[];
double trendQSign[];
double bl1Buffer[];
double bl2Buffer[];
double sl1Buffer[];
double sl2Buffer[];


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,trendQu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,trendQd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trendQ);
   SetIndexBuffer(3,trendQSign);
   SetIndexBuffer(4,bl1Buffer);
   SetIndexBuffer(5,bl2Buffer);
   SetIndexBuffer(6,sl2Buffer);
   SetIndexBuffer(7,sl1Buffer);
  
      //
      //
      //
      //
      //
      
      IndicatorShortName("Trend quality Q1 ("+TrendPeriod+","+NoisePeriod+","+DoubleToStr(CorrectionFactor,2)+","+FastLength+","+SlowLength+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double work[][7];
#define _price  0
#define _emaf   1
#define _emas   2
#define _sign   3
#define _cpc    4
#define _trend  5
#define _dt     6

//
//
//
//
//

int start()
{
   int i,k,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   double alpha1 = 2.0 / (1.0+FastLength);
   double alpha2 = 2.0 / (1.0+SlowLength);
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      work[r][_emaf]  = work[r-1][_emaf]+alpha1*(work[r][_price]-work[r-1][_emaf]);
      work[r][_emas]  = work[r-1][_emas]+alpha2*(work[r][_price]-work[r-1][_emas]);
         double macd  = work[r][_emaf]-work[r][_emas];
                        work[r][_sign] = work[r-1][_sign];
                           if (macd>0) work[r][_sign] =  1;
                           if (macd<0) work[r][_sign] = -1;
                        trendQSign[i] = work[r][_sign];

         //
         //
         //
         //
         //
      
         double change = MathAbs(work[r][_price]-work[r-1][_price]);
         if (work[r][_sign] != work[r-1][_sign])
            {
               work[r][_cpc]   = 0;
               work[r][_trend] = 0;
            }
         else
            {
               work[r][_cpc]   = work[r][_sign]*change+work[r-1][_cpc];
               work[r][_trend] = work[r][_cpc]*(1.0/TrendPeriod)+work[r-1][_trend]*(1.0-(1.0/TrendPeriod));
            }
         work[r][_dt] = (work[r][_cpc]-work[r][_trend])*(work[r][_cpc]-work[r][_trend]);
         
         //
         //
         //
         //
         //
         
         double avgDt = 0; for (k=0; k<NoisePeriod; k++) avgDt += work[r-k][_dt]; avgDt /= NoisePeriod;
         double noise = CorrectionFactor*MathSqrt(avgDt);
           if (noise != 0)
                  trendQ[i] = work[r][_trend]/noise;
            else  trendQ[i] = 0;
                  trendQu[i] = EMPTY_VALUE;
                  trendQd[i] = EMPTY_VALUE;
                     if (trendQ[i]>0)  trendQu[i] = trendQ[i];
                     if (trendQ[i]<0)  trendQd[i] = trendQ[i];

      if (DzStartBuyProbability1 >0) bl1Buffer[i] = dzBuyP (trendQ, DzStartBuyProbability1,  DzLookBackBars, Bars, i, 0.0001);
      if (DzStartBuyProbability2 >0) bl2Buffer[i] = dzBuyP (trendQ, DzStartBuyProbability2,  DzLookBackBars, Bars, i, 0.0001);
      if (DzStartSellProbability1>0) sl1Buffer[i] = dzSellP(trendQ, DzStartSellProbability1, DzLookBackBars, Bars, i, 0.0001);
      if (DzStartSellProbability2>0) sl2Buffer[i] = dzSellP(trendQ, DzStartSellProbability2, DzLookBackBars, Bars, i, 0.0001);

   }      
   return(0);
}